// Copyright 2013--2014 David Eisenstat
// Released under http://opensource.org/licenses/MIT
// mississippi April 2014 version

#include "ms.h"

#include <assert.h>
#include <stdlib.h>

int *ms_mkvci(struct ms_gr const *gr) {
  int *vci;
  MS_CALLOC(vci, (unsigned)gr->nv);
  int nd = (1 + gr->ne) * 2;
  int *st;
  MS_CALLOC(st, (unsigned)(nd - 2));
  int ci = 0;
  for (int di = 2; di < nd; di++) {
    int dj = di;
    int vj = gr->d[dj].vi;
    if (vci[vj]) {
      continue;
    }
    assert(ci < gr->nc);
    ci++;
    int nst = 0;
    goto x;
    do {
      dj = st[--nst];
      vj = gr->d[dj].vi;
      if (vci[vj]) {
        continue;
      }
     x:
      vci[vj] = ci;
      int dk = dj;
      do {
        st[nst++] = dk ^ 1;
        dk = gr->d[dk].vdi;
      } while (dk != dj);
    } while (nst);
  }
  assert(ci == gr->nc);
  free(st);
  return vci;
}

void ms_ckvci(struct ms_gr const *gr, int const *vci) {
  int nd = (1 + gr->ne) * 2;
  for (int di = 2; di < nd; di += 2) {
    int vi = gr->d[di].vi;
    int vj = gr->d[di ^ 1].vi;
    assert(vci[vi] == vci[vj]);
  }
  signed char *bc;
  MS_CALLOC(bc, (unsigned)(1 + gr->nc));
  for (int vi = 0; vi < gr->nv; vi++) {
    int ci = vci[vi];
    assert(ci >= 1);
    assert(ci <= gr->nc);
    bc[ci] = 1;
  }
  for (int ci = 1; ci <= gr->nc; ci++) {
    assert(bc[ci]);
  }
  free(bc);
}
