// Copyright 2013--2014 David Eisenstat
// Released under http://opensource.org/licenses/MIT
// mississippi April 2014 version

#include "ms.h"

#include <assert.h>
#include <limits.h>
#include <stdlib.h>

#include "dt.c"

struct ms_f *ms_mkf(struct ms_gr const *gr, int const *pr, unsigned const *k) {
  struct ms_f *f;
  MS_CALLOC(f, (unsigned)gr->nf);
  signed char *bf;
  MS_CALLOC(bf, (unsigned)gr->nf);
  int nd = (1 + gr->ne) * 2;
  int *st;
  MS_CALLOC(st, (unsigned)(nd - 2));
  for (int di = 2; di < nd; di++) {
    int fi = gr->d[di].fi;
    if (bf[fi]) {
      continue;
    }
    ms_inif(&f[fi]);
    int nst = 0;
    int dj = di;
    goto x;
    do {
      dj = st[--nst];
      fi = gr->d[dj].fi;
      if (bf[fi]) {
        continue;
      }
      ms_inif(&f[fi]);
      unsigned m = k[gr->d[dj].vi] + (unsigned)gr->d[dj ^ 1].l - \
        k[gr->d[dj ^ 1].vi];
      ms_lnkf(&f[fi],
              &f[gr->d[dj ^ 1].fi],
              m > INT_MAX ? -(int)-m : (int)m,
              dj ^ 1,
              gr->d[dj ^ 1].l + gr->d[dj].l);
     x:
      bf[fi] = 1;
      int dk = dj;
      do {
        if (pr[gr->d[dk].vi] != dk && pr[gr->d[dk ^ 1].vi] != (dk ^ 1)) {
          st[nst++] = dk ^ 1;
        }
        dk = gr->d[dk].vdi ^ 1;
      } while (dk != dj);
    } while (nst);
  }
  free(st);
  free(bf);
  return f;
}

void ms_chr(struct ms_gr const *gr, int *pr, struct ms_f *f,
            void (*op)(void *o, int cdi, int ldi), void *o,
            int rvi) {
  int ldi = 0;
  while (1) {
    int cdi = pr[rvi];
    pr[rvi] = ldi;
    if (op) {
      op(o, cdi, ldi);
    }
    if (!cdi) {
      break;
    }
    ldi = ms_pvtf(&f[gr->d[cdi ^ 1].fi],
                  &f[gr->d[cdi].fi],
                  cdi ^ 1,
                  gr->d[cdi ^ 1].l + gr->d[cdi].l);
    rvi = gr->d[ldi].vi;
  }
}
