// Copyright 2013--2014 David Eisenstat
// Released under http://opensource.org/licenses/MIT
// mississippi April 2014 version

struct ms_f {
  struct ms_f *p;
  int m;
  int di;
  int ll;
};

static void ms_evert(struct ms_f *u,
                     int cm,
                     int cdi,
                     int cll) {
  struct ms_f *c = 0;
  do {
    int m = u->ll - u->m;
    u->m = cm;
    cm = m;
    int di = u->di ^ 1;
    u->di = cdi;
    cdi = di;
    int ll = u->ll;
    u->ll = cll;
    cll = ll;
    struct ms_f *p = u->p;
    u->p = c;
    c = u;
    u = p;
  } while (u);
}

static struct ms_f *ms_findmin(struct ms_f *u) {
  struct ms_f *am = u;
  while (1) {
    u = u->p;
    if (!u) {
      break;
    }
    if (u->m < am->m) {
      am = u;
    }
  }
  return am;
}

static void ms_subcost(struct ms_f *u, int m) {
  do {
    u->m -= m;
    u = u->p;
  } while (u);
}

static void ms_inif(struct ms_f *u) {
  u->p = 0;
}

static void ms_lnkf(struct ms_f *u,
                    struct ms_f *v,
                    int m,
                    int di,
                    int ll) {
  *u = (struct ms_f){v, m, di, ll};
}

static int ms_pvtf(struct ms_f *u,
                   struct ms_f *v,
                   int di,
                   int ll) {
  ms_evert(v, ll, di, ll);
  struct ms_f *w = ms_findmin(u);
  ms_subcost(u, w->m);
  if (w != v) {
    w->p = 0;
    v->p = u;
  }
  return w->di;
}
