// Copyright 2013--2014 David Eisenstat
// Released under http://opensource.org/licenses/MIT
// mississippi April 2014 version

#include <stdlib.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <time.h>
#include <unistd.h>
#include "ms.h"
#include "submain/submain.h"

static double difftv(struct timeval z, struct timeval a) {
  return difftime(z.tv_sec, a.tv_sec) * 1e6 + ((double)z.tv_usec - a.tv_usec);
}

int main(void) {
  sync();
  struct ms_gr *gr = ms_rdgr(stdin);
  ms_ckgr(gr);
  struct timeval tva;
  struct rusage rua;
  unsigned long long np;
  struct rusage ruz;
  struct timeval tvz;
  do {
    gettimeofday(&tva, (struct timezone *)0);
    getrusage(RUSAGE_SELF, &rua);
    np = submain(gr);
    getrusage(RUSAGE_SELF, &ruz);
    gettimeofday(&tvz, (struct timezone *)0);
  } while (ruz.ru_majflt != rua.ru_majflt);
  printf("{\"vertices\": %d,\n", gr->nv);
  printf(" \"edges\": %d,\n", gr->ne);
  printf(" \"pivots\": %llu,\n", np);
  printf(" \"user\": %.0f,\n", difftv(ruz.ru_utime, rua.ru_utime));
  printf(" \"system\": %.0f,\n", difftv(ruz.ru_stime, rua.ru_stime));
  printf(" \"elapsed\": %.0f,\n", difftv(tvz, tva));
  printf(" \"maxresident\": %ld}\n", ruz.ru_maxrss);
  free(gr);
}
