// Copyright 2013--2014 David Eisenstat
// Released under http://opensource.org/licenses/MIT
// mississippi April 2014 version

#include "common.h"

#define STEP(i)                                       \
  do {                                                \
    uint64_t r = n - ((s | (UINT64_C(1) << i)) << i); \
    if (r <= n) {                                     \
      n = r;                                          \
      s |= UINT64_C(2) << i;                          \
    }                                                 \
  } while (0)

int64_t euclidean_length(struct Point p, struct Point q) {
  uint64_t x = (unsigned long long)p.x - (unsigned long long)q.x;
  uint64_t x2 = (unsigned long long)x * x;
  uint64_t y = (unsigned long long)p.y - (unsigned long long)q.y;
  uint64_t y2 = (unsigned long long)y * y;
  uint64_t n = (unsigned long long)x2 + y2;
  uint64_t s;
  if (x2 > UINT64_MAX - y2) {
    s = UINT64_C(2) << 32;
  } else {
    s = 0;
    STEP(31);
  }
  STEP(30);
  STEP(29);
  STEP(28);
  STEP(27);
  STEP(26);
  STEP(25);
  STEP(24);
  STEP(23);
  STEP(22);
  STEP(21);
  STEP(20);
  STEP(19);
  STEP(18);
  STEP(17);
  STEP(16);
  STEP(15);
  STEP(14);
  STEP(13);
  STEP(12);
  STEP(11);
  STEP(10);
  STEP(9);
  STEP(8);
  STEP(7);
  STEP(6);
  STEP(5);
  STEP(4);
  STEP(3);
  STEP(2);
  STEP(1);
  STEP(0);
  s >>= 1;
  s += n > s;
  return (int64_t)s;
}
