// Copyright 2013--2014 David Eisenstat
// Released under http://opensource.org/licenses/MIT
// mississippi April 2014 version

#include "common.h"

static void line_list_reallocate(struct Line_list **line_list_ptr,
                                 int64_t max_lines) {
  *line_list_ptr = reallocate_array(*line_list_ptr,
                                    sizeof **line_list_ptr,
                                    (uint64_t)max_lines,
                                    sizeof *(*line_list_ptr)->line);
  (*line_list_ptr)->max_lines = max_lines;
}

void line_list_initialize(struct Line_list **line_list_ptr) {
  *line_list_ptr = NULL;
  line_list_reallocate(line_list_ptr, 0);
  (*line_list_ptr)->num_lines = 0;
}

void line_list_append(struct Line line, struct Line_list **line_list_ptr) {
  assert((*line_list_ptr)->num_lines < INT64_MAX);
  if ((*line_list_ptr)->num_lines >= (*line_list_ptr)->max_lines) {
    int64_t m = (*line_list_ptr)->num_lines + 1;
    m |= m >> 1;
    m |= m >> 2;
    m |= m >> 4;
    m |= m >> 8;
    m |= m >> 16;
    m |= m >> 32;
    line_list_reallocate(line_list_ptr, m);
  }
  (*line_list_ptr)->line[(*line_list_ptr)->num_lines++] = line;
}
