// Copyright 2013--2014 David Eisenstat
// Released under http://opensource.org/licenses/MIT
// mississippi April 2014 version

#include <stdio.h>

struct ms_d {
  int vdi;
  int vi;
  int fi;
  int l;
};

struct ms_gr {
  int nc;
  int nv;
  int ne;
  int nf;
  struct ms_d d[];
};

struct ms_f;

// gr.c
struct ms_gr *ms_rdgr(FILE *fp);
void ms_wrgr(struct ms_gr const *gr, FILE *fp);
void ms_xgr(struct ms_gr *gr);
void ms_ckgr(struct ms_gr const *gr);

// pr.c
void ms_ckpr(struct ms_gr const *gr, int const *pr);
int *ms_mkt(struct ms_gr const *gr, int const *pr);

// sp.c
int *ms_mksp(struct ms_gr const *gr, unsigned **kp);
void ms_cksp(struct ms_gr const *gr, int const *pr, unsigned const *k);
unsigned *ms_mkk(struct ms_gr const *gr, int const *pr);

// f.c
struct ms_f *ms_mkf(struct ms_gr const *gr, int const *pr, unsigned const *k);
void ms_chr(struct ms_gr const *gr, int *pr, struct ms_f *f,
            void (*op)(void *o, int cdi, int ldi), void *o,
            int rvi);

// mst.c
int *ms_mkmst(struct ms_gr const *gr);
void ms_ckmst(struct ms_gr const *gr, int const *pr);

// c.c
int *ms_mkvci(struct ms_gr const *gr);
void ms_ckvci(struct ms_gr const *gr, int const *vci);

#define MS_CALLOC(a, n)               \
  do {                                \
    if ((n)) {                        \
      (a) = calloc((n), sizeof *(a)); \
      assert((a));                    \
    } else {                          \
      (a) = 0;                        \
    }                                 \
  } while (0)
