// Copyright 2013--2014 David Eisenstat
// Released under http://opensource.org/licenses/MIT
// mississippi April 2014 version

#include "ms.h"

#include <assert.h>
#include <stdlib.h>

void ms_ckpr(struct ms_gr const *gr, int const *pr) {
  signed char *bv;
  MS_CALLOC(bv, (unsigned)gr->nv);
  int nc = 0;
  int nd = (1 + gr->ne) * 2;
  for (int vi = 0; vi < gr->nv; vi++) {
    int vj = vi;
    while (!bv[vj]) {
      int di = pr[vj];
      if (!di) {
        bv[vj] = 2;
        nc++;
        break;
      }
      bv[vj] = 1;
      assert(di >= 2);
      assert(di < nd);
      assert(gr->d[di].vi == vj);
      vj = gr->d[di ^ 1].vi;
    }
    assert(bv[vj] == 2);
    vj = vi;
    while (bv[vj] == 1) {
      bv[vj] = 2;
      vj = gr->d[pr[vj] ^ 1].vi;
    }
  }
  for (int vi = 0; vi < gr->nv; vi++) {
    assert(bv[vi] == 2);
  }
  free(bv);
  assert(nc == gr->nc);
}

int *ms_mkt(struct ms_gr const *gr, int const *pr) {
  int *t;
  MS_CALLOC(t, (unsigned)gr->nv);
  int nt = 0;
  signed char *bv;
  MS_CALLOC(bv, (unsigned)gr->nv);
  for (int vi = 0; vi < gr->nv; vi++) {
    bv[vi] = !!pr[vi];
  }
  int nd = (1 + gr->ne) * 2;
  int *st;
  MS_CALLOC(st, (unsigned)(nd - 2));
  for (int di = 2; di < nd; di++) {
    int vi = gr->d[di].vi;
    if (bv[vi]) {
      continue;
    }
    bv[vi] = 1;
    int nst = 0;
    int dj = di;
    goto x;
    do {
      dj = st[--nst];
      vi = gr->d[dj].vi;
     x:
      t[nt++] = vi;
      int dk = dj;
      do {
        if (pr[gr->d[dk ^ 1].vi] == (dk ^ 1)) {
          st[nst++] = dk ^ 1;
        }
        dk = gr->d[dk].vdi;
      } while (dk != dj);
    } while (nst);
  }
  free(st);
  free(bv);
  return t;
}
