// Copyright 2013--2014 David Eisenstat
// Released under http://opensource.org/licenses/MIT
// mississippi April 2014 version

#include "set_affinity.h"
#include <assert.h>
#include <sched.h>

void set_affinity(pthread_attr_t *attr, long cpu) {
  assert(cpu < CPU_SETSIZE);
  cpu_set_t set;
  CPU_ZERO(&set);
  CPU_SET(cpu, &set);
  int err = pthread_attr_setaffinity_np(attr, sizeof set, &set);
  assert(!err);
}
