// Copyright 2013--2014 David Eisenstat
// Released under http://opensource.org/licenses/MIT
// mississippi April 2014 version

#include "submain.h"

#include <assert.h>
#include <stdlib.h>
#include "../ms.h"

static int randrange(int n) {
  assert(n > 0);
  assert(n - 1 <= RAND_MAX);
  int bits;
  int val;
  do {
    bits = rand();
    val = bits % n;
  } while (bits - val > RAND_MAX - (n - 1));
  return val;
}

static void ms_op(void *o, int cdi, int ldi) {
  (*(unsigned long long *)o)++;
}

unsigned long long submain(struct ms_gr const *gr) {
  int *vci = ms_mkvci(gr);
  ms_ckvci(gr, vci);
  unsigned *k;
  int *pr = ms_mksp(gr, &k);
  struct ms_f *f = ms_mkf(gr, pr, k);
  free(k);
  for (int ti = 0; ti < 1000; ti++) {
    unsigned long long np = 0;
    int vi = randrange(gr->nv);
    ms_chr(gr, pr, f, ms_op, &np, vi);
    np = 0;
    int vj;
    do {
      vj = randrange(gr->nv);
    } while (vci[vj] != vci[vi]);
    ms_chr(gr, pr, f, ms_op, &np, vj);
    fprintf(stderr, "%llu\n", np);
  }
  free(f);
  free(pr);
  free(vci);
  return 0;
}
