// Copyright 2013--2014 David Eisenstat
// Released under http://opensource.org/licenses/MIT
// mississippi April 2014 version

#include "submain.h"

#include <assert.h>
#include <stdlib.h>
#include "../ms.h"

enum {
  DL = 0
};

static void ms_op(void *o, int cdi, int ldi) {
  if (DL >= 3) {
    printf("c%d l%d\n", cdi, ldi);
  }
  (*(unsigned long long *)o)++;
}

unsigned long long submain(struct ms_gr const *gr) {
  unsigned *k;
  int *pr = ms_mksp(gr, &k);
  if (DL >= 1) {
    ms_cksp(gr, pr, k);
  }
  struct ms_f *f = ms_mkf(gr, pr, k);
  free(k);
  int *mstpr = ms_mkmst(gr);
  if (DL >= 2) {
    ms_ckmst(gr, mstpr);
  } else if (DL >= 1) {
    ms_ckpr(gr, mstpr);
  }
  int *t = ms_mkt(gr, mstpr);
  free(mstpr);
  unsigned long long np = 0;
  for (int ti = 0; ti < gr->nv; ti++) {
    int vi = t[ti];
    ms_chr(gr, pr, f, ms_op, &np, vi);
    assert(!pr[vi]);
    if (DL >= 2) {
      k = ms_mkk(gr, pr);
      ms_cksp(gr, pr, k);
      free(k);
    }
  }
  free(t);
  free(f);
  free(pr);
  return np;
}
